# Passit Front

passit-frontend is the angular client for [Passit](https://passit.io). It includes both the web version and mobile app.

We use smart and dumb components with ngrx/store.
Read about it [here](https://gist.github.com/btroncone/a6e4347326749f938510#utilizing-container-components)

API and crypto interaction are handled by passit-sdk-js which itself uses libsodium.js.

# Passit Web

## Install Extensions

- [Chrome Web Store](https://chrome.google.com/webstore/detail/passit/pgcleadjbkbghamecomebcdakdmahkeh)
- [Firefox addon](https://app.passit.io/ext/passit.xpi)

## Start developing

1. Install docker and docker-compose
2. Run `docker-compose up`

The front end is now running on localhost:4200 and the backend docker image is running on localhost:8000

Run any one off commands like `docker-compose run --rm web ng` to execute them inside the docker container.

You may want to run the client without docker. This is helpful when writing unit tests or for quickly adding packages. If you'd like to do this:

1. Start the backend in docker `docker-compose up api`
2. Ensure node 10 and npm are installed?
3. Install node packages `npm i`
4. Run the frontend `npm start` or use any `npm run ng` command from angular-cli.
5. You can still run the backend with docker using `docker-compose up api`

### Rebuilding when changing package.json

If you need to run `npm i` you'll want to instead run `docker-compose build` and `docker-compose rm -v app` to remove the old container.
This is because node_modules are kept in a docker volume.

## Running unit tests

Run `npm test` to execute the unit tests via [Karma](https://karma-runner.github.io).

## Running storybook

We write storybook stories for presentational components instead of unit tests. To run:

`npm run storybook`

## Coding Style and Linting

Follow style and design patterns as seen on the [ngrx example-app](https://github.com/ngrx/platform/tree/master/projects/example-app) and from angular-cli.

```bash
npm run lint
```

### Error handling

Error and validation can get complex. We have the backend API, js SDK, services, and effects as potential sources of errors. Here are some guidelines:

- Do use ngrx-forms's client side validation
- Only use ngrx-forms async validation for "as you type" server side validation. Do not use it for server errors.
- Services should handle errors and return an Observable. They should throw handled error messages as an error.
- Effects should connect services to the correct action response. Effects are glue code and should avoid complex logic (which should be in a service).

## Development for web extension

The web extension works in Firefox and Chrome. It reuses the same angular code but we need to build it differently.

For development:

We'll run this time without docker (though you could use docker). We want to build the app with aot and watch enabled for auto reload.
Then we'll run web-ext to launch the code as an extension in Firefox.

1. Run backend either in docker (`docker-compose up api`) or hosted service
2. `npm install` (if not done already)
3. `npm run build:ext -- --watch`
4. (new term) For Firefox `npm run ext:run` and for Chrome go to `dist/manifest.json` and change `"CI_INSERT_VERSION_HERE"` to a number. Open Chrome and go to `chrome://extensions/`. Ensure Developer mode is checked. Click Load unpacked and select the dist folder that is generated by the npm run build:ext step.

Because the app shares the same code, going to routes like `/popup` actually work fine in the web version. However note when not
running as an extension you won't have access to web extension api's like the browser object.

### Autofill development

Autofill code is injected into the page. It must be compiled.

1. Remove `export` from `extension/form-fill/form-fill.ts`
2. Compile with `npm build:autofill`
3. Copy and paste the resulting js file into autofill-compiled.ts as a string.

# Mobile app

Passit's mobile app runs via Nativescript. It uses a mono-repo approach described [here](https://docs.nativescript.org/angular/code-sharing/intro)
Basically a file like something.tns.ts will replace the web version of that file.

The mobile app can be installed manually, without Google Play, from [here](https://gitlab.com/passit/passit-frontend/-/jobs/artifacts/master/raw/platforms/android/app/build/outputs/apk/release/app-release.apk?job=build_android_apk)

## Install

1. Install Nativescript [See instructions for Linux](https://docs.nativescript.org/start/ns-setup-linux)
2. Ensure `tns doctor` runs.
3. Set up an emulator or physical device.

## Running

Run `tns run android`.

If using an editor which supports Typescript, make sure to set the tsconfig to tsconfig.tns.ts. You will need to switch it back and forth depending on whether you want the tsconfig for the web app or native app.

** Troubleshooting **

- Delete node modules and generated resources `rm -rf hooks platforms node_modules` then `npm i`
- `java.lang.ClassNotFoundException: com.tns.passit.AutofillService` Force a new apk build `tns build android`.
- `JavaScript heap out of memory` error run `export NODE_OPTIONS=--max-old-space-size=4096`. As mentioned [here](https://docs.nativescript.org/performance-optimizations/bundling-with-webpack#javascript-heap-out-of-memory).

### Technologies used

- [Angular](https://angular.io/) with [TypeScript](http://www.typescriptlang.org/) and [ngrx/platform](https://github.com/ngrx/platform/)
- [NativeScript](https://www.nativescript.org/) for mobile
- [libsodium.js](https://github.com/jedisct1/libsodium.js) for crypto with good defaults
